
#ifndef _ACCESSDB_H_
#define _ACCESSDB_H_

#include <libpq-fe.h>
#include <libpq/libpq-fs.h>
#include "makeps.h"

#define checkinsertstatus(res)  \
	if (res == NULL)\
                die(2, "meet error when INSERT command is being executed"); \
	else if (PQresultStatus(res) != PGRES_COMMAND_OK) \
        { \
                PQclear(res); \
                die(2, sql); \
        } 
                
#define checkselectstatus(res) \
	if (res == NULL)\
                die(2, "meet error when SELECT command is being executed"); \
	else if (PQresultStatus(res) != PGRES_TUPLES_OK)\
        { \
                PQclear(res); \
                die(2, sql); \
	} 
/*
                die(2, "meet error when SELECT command is being executed"); \
                die(2, "meet error when INSERT command is being executed"); \
                die(2, "meet error when UPDATE command is being executed"); \
*/
#define checkupdatestatus(res) \
	if (res == NULL)\
                die(2, "meet error when UPDATE command is being executed"); \
	else if (PQresultStatus(res) != PGRES_COMMAND_OK) \
        { \
                PQclear(res); \
                die(2, sql); \
        } 

#define checkdeletestatus(res) \
	if (res == NULL)\
                die(2, "meet error when DELETE command is being executed"); \
	else if (PQresultStatus(res) != PGRES_COMMAND_OK) \
        { \
                PQclear(res); \
                die(2, sql); \
        } 

#define checkcreatestatus(res) \
	if (res == NULL)\
                die(2, "meet error when CREATE command is being executed"); \
	else if (PQresultStatus(res) != PGRES_COMMAND_OK) \
        { \
                PQclear(res); \
                die(2, sql); \
        } 

#define checkdropstatus(res) \
	if (res == NULL)\
                die(2, "meet error when DROP command is being executed"); \
	else if (PQresultStatus(res) != PGRES_COMMAND_OK) \
        { \
                PQclear(res); \
                die(2, sql); \
        } 

#define begintransaction() \
	{ /* start transaction before export */\
		PGresult *res;\
		res = PQexec(conn, "BEGIN");\
		if (PQresultStatus(res) != PGRES_COMMAND_OK)\
		{\
			PQclear(res);\
			die(2, "BEGIN command failed");\
		}\
		PQclear(res);\
	}

#define endtransaction()\
	{ /* end transaction */\
		PGresult *res;\
		res = PQexec(conn, "END");\
		PQclear(res);\
	}
	
extern PGconn *conn;

extern void die(int, char *);
extern void initdbconnection();
extern void enddbconnection();
extern long exec_sql_insert(char *);
extern void export2db(struct makeprocess*);
extern void export_file(struct file *);

extern void setinvoke();

#endif
