
#ifndef _FILEDEF_H_
#define _FILEDEF_H_
/*
 * file.h 
 * */


struct file {
	long fileid;	/* internal id, automatically generated */
	char *name;
	char *dir;
	char isexported;
};

struct filelist {
	struct file *f;
	struct filelist *next;
	int order;
};

struct pidlist {
        int pid;
        struct pidlist* next;
};

struct fileinstance {
	long finstid;
	struct file *base;
	char istarget:1;
	char isphony:1;
	int  double_colon;
	int  num_dblcln;

	char *cmdstxt;
	char *execmds;
	struct pidlist *cpids;
	union {
		struct filelist *ord;
		struct fileinstlist *dbl;
	} deps;
	struct file *goal;
	int num_deps;
};

struct fileinstlist {
	struct fileinstance *finst;
	struct fileinstlist *next;
	int order;
};

extern struct file *_file(char *, char *);
extern struct fileinstance *_fileinstance(struct file *, struct file *);
extern struct fileinstlist *_fileinstlist(struct fileinstlist *, struct fileinstance*);
extern struct filelist *_filelist(struct filelist *, struct file *);
extern struct file *locatefile(const char *, const char *);
struct fileinstance *finst_add_dblcln(struct fileinstance *tmpl);

extern void init_hashtable();
extern void free_hashtable();

extern void file_writeout(struct file *);
extern void finst_writeout(struct fileinstance *);
extern void flist_writeout(struct fileinstlist *);

extern void export_file_table();

#endif
