#ifndef _INTRAGRAPH_H_
#define _INTRAGRAPH_H_

struct GraphEdge;

struct GraphNode {
	long id;
	char * dir;
	char * name;
	int  dblcln;
	char isdblcln;
	char istarget;
	char isphony;
	char isgoal;
	struct GraphEdge *edges;
	char isvisited;
};

struct GraphEdge {
	struct GraphNode * to;
	struct GraphEdge * next;
};

struct Graph {
	struct GraphEdge *startpoint;
	long   capacity;
	struct GraphNode** nodes;
};

extern struct GraphNode * GraphNode_(long, char*, char*, int, int, int, int, int);
extern struct GraphEdge * GraphEdge_(struct GraphNode *, struct GraphEdge *);
extern struct Graph * Graph_(int);
extern void graphnode_free(struct GraphNode *);
extern void graphedge_free(struct GraphEdge *);
extern void graph_free(struct Graph*);
extern struct Graph * init_graph(const char*);

#endif
