
#ifndef _MAKEPS_H_
#define _MAKEPS_H_

#include "variable.h"
#include "filedef.h"

struct makeprocess {
	char *buildname;
	long procid;

	char *commandline;
	char *curdir;
	int pid;
	int ppid;
	struct varlist *vars;
	struct fileinstlist *files;	
	struct filelist *goals;
};

struct makepslist {
	struct makeprocess *ps;
	struct makepslist *next;
};

extern struct makeprocess *_makeprocess();
extern struct makepslist  *_makepslist(struct makepslist *, struct makeprocess *);

extern void ps_free(struct makeprocess *);
extern void pslist_free(struct makepslist *);
extern void ps_writeout(struct makeprocess *);
extern struct fileinstance * ps_addfileinst(struct makeprocess *, struct file *, char *, int);
extern struct file *ps_addgoal(struct makeprocess *, char *, int);

#endif
