
#ifndef _VARIABLE_H_
#define _VARIABLE_H_
/*
 * variable.h
 * */
enum varsource {
	o_default = 1,      /* Variable from the default set.  */
	o_env,              /* Variable from environment.  */
	o_file,             /* Variable given in a makefile.  */
	o_env_override,     /* Variable from environment, if -e.  */
	o_command,          /* Variable given by user.  */
	o_override,         /* Variable from an `override' directive.  */
	o_automatic,        /* Automatic variable -- cannot be set.  */
	o_invalid           /* Core dump time.  */			    
};

struct var {
	char *name;
	char *value;
	enum varsource source;
};

struct varlist {
	struct var *v;
	struct varlist *next;
};

extern struct var *_var(char *, char *, enum varsource);
extern struct varlist *_varlist(struct varlist *, char *, char *, enum varsource);
extern void vl_writeout(struct varlist *);

#endif
