
#include <stdio.h>
#include <string.h>
#include "read.h"
#include "filedef.h"
#include "util.h"

enum commandtype {
	c_loadlog,
	c_setinvoke,
	c_reviewinvoke,
	c_continvoke,
	c_export,
	c_compare,
	c_listbnm,
	c_quit,
	c_removelog,
	c_help
};

static void print_usage()
{
	printf("\n");
	printf("[1] Load log file into database \n");
	printf("[2] Set INVOKE relation between make and submake\n");
	printf("[3] Review INVOKE relation\n");
	printf("[4] Continue setting INVOKE relation\n");
	printf("[5] Export to build time facts \n");
	printf("[6] Compare two system buildings \n");
	printf("[L] List all system buildings\n");
	printf("[R] Remove from database\n");
	printf("[X] Exit the program\n");
	printf("[?] Help\n");
	printf("\n");
}

static enum commandtype get_command()
{
	char result;
	
	printf("\nMain: Your choice => ");

	while (1) {
		scanf("%c", &result);
		switch (result) {
			case '1': return c_loadlog;
			case '2': return c_setinvoke;
			case '3': return c_reviewinvoke;
			case '4': return c_continvoke;
			case '5': return c_export;
			case '6': return c_compare;
			case 'L': return c_listbnm;
			case 'R': return c_removelog;
			case 'X': return c_quit;
			case '?': return c_help;
			case '\n': break;
			default : printf("\nBad Choice! Reenter your choice => ");
		}
	}
}

void main_menu()
{
	enum commandtype cmd;

	print_usage();
	while (1)
	{
		cmd = get_command();
		switch (cmd)
		{
			case c_loadlog:		loadlog(); break;
				
			case c_setinvoke:	setinvoke(); break;

			case c_reviewinvoke:	reviewinvoke(); break;
						
			case c_continvoke:	continvoke();break;

			case c_export:		toRSF(); break;
						
			case c_compare:		comparebtv(); break;
						
			case c_listbnm:		listbnm(); break;
						
			case c_help:		print_usage(); break;

			case c_quit: 		return;

			case c_removelog:	remove_log(); break;
		}
	}
}

int main(int argc, char **argv, char**envp)
{
	enum commandtype cmd;
	
	init_hashtable();
	initdbconnection();

	main_menu();
	printf("\nLeaving program ...\n");

	enddbconnection();
	free_hashtable();
	print_memory();
}
