
#include "variable.h"
#include <util.h>
#include <string.h>

struct var *_var(char *n, char *v, enum varsource vs)
{
	struct var *result = (struct var *)xmalloc(sizeof(*result));
	result->name = n;
	result->value = v;
	result->source = vs;
	return result;
}

void var_free(struct var *v)
{
	free (v->name);
	free (v->value);
	free (v);
}

struct varlist *_varlist(struct varlist *head, char *n, char *v, enum varsource vs)
{
	struct varlist *result = (struct varlist *)xmalloc(sizeof(*result));
	result->v = _var(n, v, vs);
	result->next = head;
	return result;
}

void varlist_free(struct varlist *ls)
{
	struct varlist *head;
	
	while (ls)
	{
		head = ls;
		var_free(head->v);
		ls = ls->next;
		free(head);
	}
}

void var_writeout(struct var *v)
{
	printf("%s=%s\n", v->name, v->value);
}

void vl_writeout(struct varlist *ls)
{
	while (ls)
	{
		var_writeout(ls->v);
		ls = ls->next;
	}
}
