
#include "query.h"
#include <assert.h>

PGconn *conn;
FILE *infp, *outfp;

#define exec_select(res, sql)\
	res = PQexec(conn, sql);\
	if (res == NULL)\
                die("meet error when SELECT command is being executed");\
        else if (PQresultStatus(res) != PGRES_TUPLES_OK)\
        { \
		PQclear(res); \
		die(sql); \
	}

static void find_diff(const char *va, const char *vb)
{
	char sql[512];
	PGresult *res_a, *res_b;
	char buf_name[512], buf_dir1[512], buf_dir2[512];
	int i, j, c;
	
	char *c_sql = "SELECT OID \
			 FROM BTV_FILEINST\
			WHERE INST_VERSION = '%s' \
			  AND INST_NAME = '%s'\
			  AND INST_DIR = '%s' ";
	c = 0;
	while (fscanf(infp, "%s\t%s\t%s", buf_name, buf_dir1, buf_dir2) != EOF)
	{
		sprintf(sql, c_sql, va, buf_name, buf_dir1);
		exec_select(res_a, sql);
		sprintf(sql, c_sql, vb, buf_name, buf_dir2);
		exec_select(res_b, sql);

		for (i = 0; i < PQntuples(res_a); i++)
			for (j = 0; j < PQntuples(res_b); j++)
				fprintf(outfp, "DIFF\t%s\t%s\n", 
						PQgetvalue(res_a, i, 0), 
						PQgetvalue(res_b, j, 0));
		PQclear(res_a);
		PQclear(res_b);
		c++;
		printf("%d\n", c);
	}
}

int main(int argc, char **argv, char**envp)
{
	if (argc < 5)
	{
		printf("Environment Comparison: Do Not have ENOUGH params. \n");
		printf("Do nothing!\n");
		return 0;
	}

	infp = fopen(argv[1], "r");
	if (!infp) {
		printf("Can not open file.\n");
		return 1;
	}
	
	outfp = fopen(argv[2], "w");
	if (!outfp) {
		printf("Can not open file.\n");
		return 1;
	}
	
	initdbconnection();
	begintransaction();
	
	find_diff(argv[3], argv[4]);

	endtransaction();
	enddbconnection();
	
	fprintf(outfp, "\n");
	close (outfp);
}
#undef exec_select
