
#include "query.h"

PGconn *conn;
FILE *outfp;

static query_cmdline(const char *oid)
{
	PGresult *res;
	char sql[512];
	
	sprintf(sql, "SELECT INST_NAME, INST_DIR, PS_CMDLINE\
			FROM BTV_MAKEPROC, BTV_FILEINST\
		       WHERE BTV_FILEINST.OID = %s\
		         AND INST_PROC = BTV_MAKEPROC.OID", oid);
	res = PQexec(conn, sql);
        if (res == NULL)
                die("meet error when SELECT command is being executed"); 
        else if (PQresultStatus(res) != PGRES_TUPLES_OK)
        { 
		PQclear(res); 
		die(sql); 
	}

	if (PQntuples(res) < 1)
	{
		die("There no such file, the data file may not be up-to-date");
	}

	fprintf(outfp, " \n==========================================\n");
	fprintf(outfp, " \nCommand Line for %s/%s\n", 
			PQgetvalue(res, 0, 1), PQgetvalue(res, 0, 0));
	
	fprintf(outfp, " \n------------------------------------------\n");
	fprintf(outfp, " \n");
	print_cmd(PQgetvalue(res, 0, 2), outfp);

	fprintf(outfp, " \n==========================================\n");
	fprintf(outfp, " \n");

	PQclear(res);
}

int main(int argc, char **argv, char**envp)
{
	int i;

	if (argc < 3)
	{
		fprintf(outfp, "CmdLine Query: Not enough params. \n");
		fprintf(outfp, "               Do nothing!!!\n");
		return 0;
	}

	outfp = fopen(argv[1], "w");
	if (!outfp) {
		fprintf(outfp, "Can not open file");
		return 1;
	}
	
	initdbconnection();
	begintransaction();
	
	for (i = 2; i < argc; i ++)
		query_cmdline(argv[i]);

	endtransaction();
	enddbconnection();
	fprintf(outfp, "\n");
	close (outfp);
}
